<?php

declare(strict_types = 1);

namespace Drupal\form_decorator_example\FormDecorator;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\form_decorator\FormDecoratorBase;

/**
 * @FormDecorator(hook = "form_user_register_form_alter")
 */
final class ValidateOnly extends FormDecoratorBase {
  use StringTranslationTrait;

  /**
   *
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    $this->inner->validateForm($form, $form_state);
    if (strlen($form_state->getValue('name')) < 7) {
      $form_state->setErrorByName('name', $this->t('Your username should at least have 7 characters.'));
    }
  }

}
