<?php

namespace Drupal\form_decorator;

use Drupal\Core\Form\FormInterface;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Entity\EntityFormInterface;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\StringTranslation\TranslationInterface;

class EntityFormDecoratorBase extends FormDecoratorBase implements EntityFormInterface {

  /**
   * @var EntityFormInterface
   */
  protected FormInterface $inner;

  /**
   * {@inheritdoc}
   */
  public function getEntity() {
    return $this->inner->getEntity();
  }

  public function getOperation() {
    return $this->inner->getOperation();
  }

  public function setOperation($operation)  {
    return $this->inner->setOperation($operation);
  }

  public function setEntity(EntityInterface $entity) {
    return $this->inner->setEntity($entity);
  }

  public function getEntityFromRouteMatch(RouteMatchInterface $route_match, $entity_type_id) {
    return $this->inner->getEntityFromRouteMatch($route_match, $entity_type_id);
  }

  public function buildEntity(array $form, FormStateInterface $form_state) {
    return $this->inner->buildEntity($form, $form_state);
  }

  public function save(array $form, FormStateInterface $form_state) {
    return $this->inner->save($form, $form_state);
  }

  public function setStringTranslation(TranslationInterface $string_translation) {
    return $this->inner->setStringTranslation($string_translation);
  }

  public function setModuleHandler(ModuleHandlerInterface $module_handler) {
    return $this->inner->setModuleHandler($module_handler);
  }

  public function setEntityTypeManager(EntityTypeManagerInterface $entity_type_manager) {
    return $this->inner->setEntityTypeManager($entity_type_manager);
  }

  public function getBaseFormId() {
    return $this->inner->getBaseFormId();
  }
}