<?php

namespace Drupal\form_decorator;

use Drupal\Core\Form\FormBuilder;
use Drupal\Core\Form\FormStateInterface;
use Drupal\form_decorator\FormDecoratorInterface;

/**
 * Add decorators to form objects.
 */
class FormDecoratorFormBuilder extends FormBuilder {

  /**
   * {@inheritdoc}
   */
  public function getFormId($form_arg, FormStateInterface &$form_state) {
    parent::getFormId($form_arg, $form_state);
    $form_arg = $form_state->getFormObject();

    /** @var \Drupal\form_decorator\FormDecoratorPluginManager $form_decorator_manager */
    $form_decorator_manager = \Drupal::service('plugin.manager.form_decorator');
    $definitions = $form_decorator_manager->getDefinitions();

    // Decorate Forms that have a matching hook.
    foreach (array_keys($definitions) as $id) {
      /** @var FormDecoratorInterface $instance */
      $instance = $form_decorator_manager->createInstance($id);
      $instance->setInner($form_arg);
      if ($instance->applies()) {
        $form_arg = $instance;
      }
    }

    $form_state->setFormObject($form_arg);
    return $form_arg->getFormId();
  }

}
