<?php

namespace Drupal\form_decorator;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceModifierInterface;
use Drupal\Core\Form\FormBuilder;

/**
 * Chnage the form builder class.
 */
class FormDecoratorServiceProvider implements ServiceModifierInterface {

  /**
   * {@inheritdoc}
   */
  public function alter(ContainerBuilder $container) {
    if ($container->has('form_builder') && is_a($container->getDefinition('form_builder')->getClass(), FormBuilder::class, TRUE)) {
      $container->getDefinition('form_builder')->setClass(FormDecoratorFormBuilder::class);
    }
  }

}
